/**
 * DevExtreme (cjs/__internal/grids/grid_core/keyboard_navigation/dom.js)
 * Version: 23.2.8 (build 24231-0111)
 * Build date: Sun Aug 18 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GridCoreKeyboardNavigationDom = void 0;
var _const = require("./const");
const isDragCell = $cell => void 0 !== $cell.attr(_const.ATTRIBUTES.dragCell);
const getFocusableCellSelector = columnIndex => ["[".concat(_const.ATTRIBUTES.ariaColIndex, '="').concat(columnIndex + 1, '"]'), ":not([".concat(_const.ATTRIBUTES.dragCell, "])"), ":not([aria-hidden=true])"].join("");
const getCellToFocus = ($cellElements, columnIndex) => $cellElements.filter(getFocusableCellSelector(columnIndex)).first();
const GridCoreKeyboardNavigationDom = {
    isDragCell: isDragCell,
    getCellToFocus: getCellToFocus
};
exports.GridCoreKeyboardNavigationDom = GridCoreKeyboardNavigationDom;
