/**
 * DevExtreme (cjs/__internal/ui/overlay/m_utils.js)
 * Version: 23.2.8 (build 24231-0111)
 * Build date: Sun Aug 18 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getElementMaxHeightByWindow = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _size = require("../../../core/utils/size");
var _type = require("../../../core/utils/type");
var _window = require("../../../core/utils/window");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
const WINDOW_HEIGHT_PERCENT = .9;
const getElementMaxHeightByWindow = ($element, startLocation) => {
    const $window = (0, _renderer.default)((0, _window.getWindow)());
    const {
        top: elementOffset
    } = $element.offset();
    let actualOffset;
    if ((0, _type.isNumeric)(startLocation)) {
        if (startLocation < elementOffset) {
            return elementOffset - startLocation
        }
        actualOffset = (0, _size.getInnerHeight)($window) - startLocation + $window.scrollTop()
    } else {
        const offsetTop = elementOffset - $window.scrollTop();
        const offsetBottom = (0, _size.getInnerHeight)($window) - offsetTop - (0, _size.getOuterHeight)($element);
        actualOffset = Math.max(offsetTop, offsetBottom)
    }
    return .9 * actualOffset
};
exports.getElementMaxHeightByWindow = getElementMaxHeightByWindow;
