/**
 * DevExtreme (cjs/__internal/ui/tabs/m_item.js)
 * Version: 23.2.8 (build 24231-0111)
 * Build date: Sun Aug 18 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _m_item = _interopRequireDefault(require("../../ui/collection/m_item"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}
const TABS_ITEM_BADGE_CLASS = "dx-tabs-item-badge";
const BADGE_CLASS = "dx-badge";
const TabsItem = _m_item.default.inherit({
    _renderWatchers() {
        this.callBase();
        this._startWatcher("badge", this._renderBadge.bind(this))
    },
    _renderBadge(badge) {
        this._$element.children(".".concat("dx-badge")).remove();
        if (!badge) {
            return
        }
        const $badge = (0, _renderer.default)("<div>").addClass("dx-tabs-item-badge").addClass("dx-badge").text(badge);
        this._$element.append($badge)
    }
});
var _default = TabsItem;
exports.default = _default;
