/**
 * DevExtreme (esm/__internal/scheduler/r1/components/base/group_panel_horizontal_row.js)
 * Version: 23.2.8 (build 24231-0111)
 * Build date: Sun Aug 18 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import {
    createVNode,
    createComponentVNode
} from "inferno";
import {
    BaseInfernoComponent
} from "@devextreme/runtime/inferno";
import {
    getTemplate
} from "../../../../core/r1/utils/index";
import {
    GroupPanelHorizontalCell,
    GroupPanelHorizontalCellDefaultProps
} from "./group_panel_horizontal_cell";
import {
    GroupPanelRowDefaultProps
} from "./group_panel_props";
export class GroupPanelHorizontalRow extends BaseInfernoComponent {
    render() {
        var {
            cellTemplate: cellTemplate,
            className: className,
            groupItems: groupItems
        } = this.props;
        var CellTemplateComponent = getTemplate(cellTemplate);
        return createVNode(1, "tr", "dx-scheduler-group-row ".concat(className), groupItems.map((_ref, index) => {
            var {
                colSpan: colSpan,
                color: color,
                data: data,
                id: id,
                isFirstGroupCell: isFirstGroupCell,
                isLastGroupCell: isLastGroupCell,
                key: key,
                text: text
            } = _ref;
            return createComponentVNode(2, GroupPanelHorizontalCell, {
                text: text,
                id: id,
                data: data,
                index: index,
                color: color,
                colSpan: null !== colSpan && void 0 !== colSpan ? colSpan : GroupPanelHorizontalCellDefaultProps.colSpan,
                isFirstGroupCell: !!isFirstGroupCell,
                isLastGroupCell: !!isLastGroupCell,
                cellTemplate: CellTemplateComponent
            }, key)
        }), 0)
    }
}
GroupPanelHorizontalRow.defaultProps = GroupPanelRowDefaultProps;
